#cs ----------------------------------------------------------------------------

 Version AutoIt : 3.2.0.1
 Auteur: EP

 Description de la macro :
	Conversion de fichiers multicanaux .MLP en fichiers WAV, WAVEPACK ou FLAC
	Tous les fichiers externes utiliss doivent imprativement tre situs dans :
	C:\Program Files\MLP2all
	Cette macro Ncessite en plus l'installation de Surcode MLP dans le dossier :
	C:\Program Files\Minnetonka Audio Software\SurCode MLP
#ce ----------------------------------------------------------------------------
#include <GUIConstants.au3>

Opt("GUIOnEventMode", 1)  ; Mode "OnEvent" pour la gestion du GUI

; Sauvegarde des paramtres de Surcode MLP qui vont tre modifis
$down = RegRead("HKEY_CURRENT_USER\Software\Minnetonka Audio Software\Surcode MLP\OPTIONS", "DOWNMIX")
$verif = RegRead("HKEY_CURRENT_USER\Software\Minnetonka Audio Software\Surcode MLP\OPTIONS", "VERIFYWHILEENCODING")
$write = RegRead("HKEY_CURRENT_USER\Software\Minnetonka Audio Software\Surcode MLP\OPTIONS", "WRITEWAVSWHILEVERIFYING")

; Cration GUI fentre paramtrage transcodage =======================================
$mainwindow = GUICreate("Transcodage MLP", 320, 405)
GUISetOnEvent($GUI_EVENT_CLOSE, "ArretMacro")

	; GROUPE Dcodage MLP ----------------------------------------
	GuiCtrlCreateGroup("Dcodage MLP", 20, 15, 280,185)

	$Dossier_button = GuiCtrlCreateButton("Dossier source", 110, 45, 100, 30)
	GUICtrlSetOnEvent($Dossier_button, "RepButton")
	$chemin = ""

	$Multicanal_radio = GuiCtrlCreateRadio("Multicanal uniquement", 40, 95, 170)
	GuiCtrlSetState(-1, $GUI_CHECKED)
	GUICtrlSetOnEvent($Multicanal_radio, "DecodageFlag")
	RegWrite("HKEY_CURRENT_USER\Software\Minnetonka Audio Software\Surcode MLP\OPTIONS","DOWNMIX","REG_DWORD",0)
	$decodage = "mc"
	$Downmix_radio = GuiCtrlCreateRadio("Downmix stro uniquement", 40, 115, 170)
	GUICtrlSetOnEvent($Downmix_radio, "DecodageFlag")
	
	$all_radio = GuiCtrlCreateRadio("Multicanal plus downmix stro", 40, 135, 170)
	GUICtrlSetOnEvent($all_radio, "DecodageFlag")

	$EffaceMLP_checkbox = GuiCtrlCreateCheckbox("Effacement des fichiers MLP aprs dcodage", 40, 165)
	GuiCtrlSetState(-1, $GUI_CHECKED)
	$effaceMLP = 1
	GUICtrlSetOnEvent($EffaceMLP_checkbox, "EffaceMLPFlag")

	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	; GROUPE Encodage ------------------------------------------
	GuiCtrlCreateGroup("Encodage", 20, 220, 280,170)

	$mono_radio = GuiCtrlCreateRadio("Mono", 60, 250, 100)
	GUICtrlSetOnEvent($mono_radio, "FormatFlag")
	$stereo_radio = GuiCtrlCreateRadio("Stro", 60, 270, 100)
	GUICtrlSetOnEvent($stereo_radio, "FormatFlag")
	$mc_radio = GuiCtrlCreateRadio("Multicanal", 60, 290, 100)
	GuiCtrlSetState(-1, $GUI_CHECKED)
	$format = "mc"
	GUICtrlSetOnEvent($mc_radio, "FormatFlag")
	$4ch_radio = GuiCtrlCreateRadio("Multicanal sans surround", 60, 310, 140)
	GUICtrlSetOnEvent($4ch_radio, "FormatFlag")
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group
	
	
	$wav_radio = GuiCtrlCreateRadio("wav", 180, 250, 100)
	GUICtrlSetOnEvent($wav_radio, "CibleFlag")
	$wv_radio = GuiCtrlCreateRadio("WavPack", 180, 270, 100)
	GUICtrlSetOnEvent($wv_radio, "CibleFlag")
	$flac_radio = GuiCtrlCreateRadio("flac", 180, 290, 100)
	GuiCtrlSetState(-1, $GUI_CHECKED)
	$cible = "flac"
	GUICtrlSetOnEvent($flac_radio, "CibleFlag")
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	$Go_button = GuiCtrlCreateButton("Go!", 110, 345, 100, 30)
	GUICtrlSetOnEvent($Go_button, "Transcodage")


; Cration GUI fentre progression transcodage =======================================
$progresswindow = GUICreate("Transcodage en cours", 390, 90,30,30)
GUISetOnEvent($GUI_EVENT_CLOSE, "ArretMacro")

$label_nbMLP = GuiCtrlCreateLabel("Nombre de fichiers MLP  transcoder : ", 20, 20)

$bar_progress = GuiCtrlCreateProgress(90, 50, 272, 20,$PBS_SMOOTH )
GuiCtrlCreateLabel("Progression:", 20, 50)
; Fin cration des GUI ===============================================================
; Passage  la gestion des vnements !


; programme principal ================================================================

; Affichage GUI paramtrage
GUISwitch($mainwindow)
GUISetState(@SW_SHOW)

; On ne fait rien en attendant les vnements...
While 1
  Sleep(1000)
WEnd

;--------------------------------------------------
Func ArretMacro()
; Retour aux paramtres d'origine
RegWrite("HKEY_CURRENT_USER\Software\Minnetonka Audio Software\Surcode MLP\OPTIONS","DOWNMIX","REG_DWORD",$down)
RegWrite("HKEY_CURRENT_USER\Software\Minnetonka Audio Software\Surcode MLP\OPTIONS","VERIFYWHILEENCODING","REG_DWORD",$verif)
RegWrite("HKEY_CURRENT_USER\Software\Minnetonka Audio Software\Surcode MLP\OPTIONS","WRITEWAVSWHILEVERIFYING","REG_DWORD",$write)
Exit
EndFunc

;--------------------------------------------------
Func RepButton()
; Choix du dossier contenant les fichiers .MLP
$chemin = FileSelectFolder ( "Slectionnez le dossier contenant les fichiers MLP  convertir", "")
If @error Then ArretMacro()
FileChangeDir ($chemin)
EndFunc

;--------------------------------------------------
Func DecodageFlag()
; Choix du type de dcodage MLP voulu
Switch @GUI_CTRLID
Case $Multicanal_radio
	$decodage = "mc"
	GUICtrlSetState ( $mc_radio, $GUI_ENABLE )
	GUICtrlSetState ( $4ch_radio, $GUI_ENABLE )
	GUICtrlSetState ( $mc_radio, $GUI_CHECKED )
	$format = "mc"
	RegWrite("HKEY_CURRENT_USER\Software\Minnetonka Audio Software\Surcode MLP\OPTIONS","DOWNMIX","REG_DWORD",0)
Case $Downmix_radio
	$decodage = "downmix"
	GUICtrlSetState ( $stereo_radio, $GUI_CHECKED )
	$format = "stereo"
	GUICtrlSetState ( $mc_radio, $GUI_DISABLE )
	GUICtrlSetState ( $4ch_radio, $GUI_DISABLE )
	RegWrite("HKEY_CURRENT_USER\Software\Minnetonka Audio Software\Surcode MLP\OPTIONS","DOWNMIX","REG_DWORD",1)
Case $all_radio
	$decodage = "all"
	GUICtrlSetState ( $mc_radio, $GUI_ENABLE )
	GUICtrlSetState ( $4ch_radio, $GUI_ENABLE )
	GUICtrlSetState ( $mc_radio, $GUI_CHECKED )	
	$format = "mc"	
	RegWrite("HKEY_CURRENT_USER\Software\Minnetonka Audio Software\Surcode MLP\OPTIONS","DOWNMIX","REG_DWORD",1)
EndSwitch
EndFunc

;--------------------------------------------------
Func EffaceMLPFlag()
$effaceMLP = NOT $effaceMLP	
EndFunc

;--------------------------------------------------
Func FormatFlag()
Switch @GUI_CTRLID
Case $mono_radio
	$format = "mono"
	GUICtrlSetState ( $wav_radio, $GUI_CHECKED )
	$cible = "wav"
	GUICtrlSetState ( $wv_radio, $GUI_DISABLE )		
	GUICtrlSetState ( $flac_radio, $GUI_DISABLE )		
Case $stereo_radio
	$format = "stereo"
	GUICtrlSetState ( $wv_radio, $GUI_ENABLE )		
	GUICtrlSetState ( $flac_radio, $GUI_ENABLE )		
Case $mc_radio
	$format = "mc"
	GUICtrlSetState ( $wv_radio, $GUI_ENABLE )		
	GUICtrlSetState ( $flac_radio, $GUI_ENABLE )		
Case $4ch_radio
	$format = "4ch"
	GUICtrlSetState ( $wv_radio, $GUI_ENABLE )		
	GUICtrlSetState ( $flac_radio, $GUI_ENABLE )		
EndSwitch 
EndFunc

Func CibleFlag()
Switch @GUI_CTRLID
Case $wav_radio
	$cible = "wav"
Case $wv_radio
	$cible = "wavpack"
Case $flac_radio
	$cible = "flac"
EndSwitch 
EndFunc

;--------------------------------------------------
Func Transcodage()
; on cache le GUI de paramtrage
GUISetState(@SW_HIDE)

; Recherche de tous les fichiers MLP ds le dossier courant
$search = FileFindFirstFile("*.MLP")  

; A t'on trouv des fichiers MLP ?
If $search = -1 Then
    MsgBox(0, "Erreur", "Pas de fichiers MLP dans le dossier slectionn")
    ArretMacro()
EndIf

; Comptage du nombre total de fichiers MLP  transcoder
$nbTotalMLP = 0;
While 1
    $file = FileFindNextFile($search)
    If @error Then ExitLoop
	$nbTotalMLP += 1
WEnd
FileClose($search)
GuiCtrlSetData($label_nbMLP, "Nombre de fichiers MLP  transcoder : " & $nbTotalMLP)

; Affichage du GUI de progression de l'encodage
GUISwitch($progresswindow)
GUISetState(@SW_SHOW)

; Configuration de Surcode MLP pour avoir un dcodage correct
RegWrite("HKEY_CURRENT_USER\Software\Minnetonka Audio Software\Surcode MLP\OPTIONS","VERIFYWHILEENCODING","REG_DWORD",0)
RegWrite("HKEY_CURRENT_USER\Software\Minnetonka Audio Software\Surcode MLP\OPTIONS","WRITEWAVSWHILEVERIFYING","REG_DWORD",1)
; Lancement de Surcode MLP
Run("C:\Program Files\Minnetonka Audio Software\SurCode MLP\surcodemlp.exe","C:\Program Files\Minnetonka Audio Software\SurCode MLP")
; Attente que Surcode MLP devienne actif
WinWaitActive("MLP Encoder")

; Ouvre le fichier de configuration situ dans C:\Program Files\MLP2all
Send("!s{DOWN}{ENTER}")
Send("C:\Program Files\MLP2all\Surcode.ssf")
Send("{TAB}{TAB}{ENTER}")

; Slection du fichier MLP bidon  crer dans $chemin
$fichier_bidon = $chemin & "\bidon.MLP"
Opt ( "MouseCoordMode", 2 )
MouseClick ( "left", 60, 80,1,0 )
Send($fichier_bidon)
Send("{TAB}{TAB}{ENTER}")

; Envoi d'un "close"  Surcode pour fermer cette application
WinClose("MLP Encoder")
; Attente que Surcode soit ferm avant de continuer
WinWaitClose("MLP Encoder")

; Dmarrage de la conversion de chaque fichier MLP situ dans $chemin
$search = FileFindFirstFile("*.MLP")  

$nbTotalMLP *= 2
$nbMLP = 0;
While 1
	
	; Slection du fichier  convertir
    $file = FileFindNextFile($search)
    If @error Then ExitLoop ; on a tout transcod !

	; fichier  traiter sans extension
	$file_sans_ext = StringLeft($file, StringLen($file)-4)

	; fichier  traiter avec extension .wav au lieu de .MLP
	$file_wav = $file_sans_ext & ".wav"

	; La barre de progression va tre mise  jour DEUX fois pour chaque fichier transcod
	; 1re MJ barre de progression
	$nbMLP+=1
	GuiCtrlSetData($bar_progress, Int($nbMLP / $nbTotalMLP * 100))

	; Lancement de Surcode MLP
	Run("C:\Program Files\Minnetonka Audio Software\SurCode MLP\surcodemlp.exe","C:\Program Files\Minnetonka Audio Software\SurCode MLP")
	; Attente que Surcode MLP devienne actif
	WinWaitActive("MLP Encoder")

	; Lancement de l'encodage bidon (wav contenant 1 sec de silence) dans $chemin
	MouseClick ( "left", 30, 320,1,0 )

	; Attente de la fin de l'encodage
	WinWaitActive("MLP Encoder Log File")

	; Copie du bon fichier MLP (celui  dcoder)  la place du fichier bidon qui vient d'tre encod 
	; Comme la copie peut tre longue, on attend qu'elle se soit correctement termine
	$fichier_a_convertir = $chemin & "\" & $file
	If Not FileCopy ($fichier_a_convertir, $fichier_bidon, 1 ) Then 
			ArretMacro()
	EndIf
		
	; Suppression du MLP d'origine si l'utilisateur l'a demand	
	If $effaceMLP Then
		FileDelete ($fichier_a_convertir)
	EndIf
	
	; Lancement de la vrification qui va dcoder le fichier MLP en crant 3 fichiers wav dans $chemin :
	; surcode_lfrf.wav  surcode_clfe.wav  surcode_lsrs.wav  
	; Si en plus l'utilisateur a demand le downmix stro, un 4e fichier est cr : surcode_down.wav
	WinActivate ("MLP Encoder Log File")
	MouseClick ( "left", 310, 480,1,0 )

	; Attente de la fin de la vrification (ie fin du dcodage MLP)
	WinWaitActive("MLP Verify Log File")
	MouseClick ( "left", 310, 480,1,0 )

	; Envoi d'un "close"  Surcode pour fermer cette application
	; Ceci est ncessaire pour avoir accs aux fichiers wav 
	WinClose("MLP Encoder")
	; Attente que Surcode soit ferm avant de continuer
	WinWaitClose("MLP Encoder")

	; Suppression du fichier MLP dans $chemin
	FileDelete ($fichier_bidon)
	
	; 2e MJ barre de progression
	$nbMLP+=1
	GuiCtrlSetData($bar_progress, Int($nbMLP / $nbTotalMLP * 100))

	; On passe maintenant  l'encodage !
	; ----------------------------------
	
	If $format = "mono" Then
		; on extrait les wav mono  partir des fichiers wav stro crs par Surcode
		; et comme la seule cible autorise dans ce cas est "wav", on copie tous ces 
		; wav mono dans le dossier ..\wav avec des noms de fichier corrects.
		If $decodage <> "downmix" Then
			$appl = "C:\Program Files\MLP2all\channelx.exe surcode_lfrf.wav 1 2"
			RunWait($appl,$chemin)
			FileMove($chemin & "\surcode_lfrf_c1.wav", $chemin & "\wav\" & $file_sans_ext & "_FL.wav",8)
			FileMove($chemin & "\surcode_lfrf_c2.wav", $chemin & "\wav\" & $file_sans_ext & "_FR.wav",8)

			$appl = "C:\Program Files\MLP2all\channelx.exe surcode_clfe.wav 1 2"
			RunWait($appl,$chemin)
			FileMove($chemin & "\surcode_clfe_c1.wav", $chemin & "\wav\" & $file_sans_ext & "_C.wav",8)
			FileMove($chemin & "\surcode_clfe_c2.wav", $chemin & "\wav\" & $file_sans_ext & "_LFE.wav",8)
		
			$appl = "C:\Program Files\MLP2all\channelx.exe surcode_lsrs.wav 1 2"
			RunWait($appl,$chemin)
			FileMove($chemin & "\surcode_lsrs_c1.wav", $chemin & "\wav\" & $file_sans_ext & "_SL.wav",8)
			FileMove($chemin & "\surcode_lsrs_c2.wav", $chemin & "\wav\" & $file_sans_ext & "_SR.wav",8)
		EndIf
		FileDelete ( $chemin & "\surcode_lfrf.wav" )
		FileDelete ( $chemin & "\surcode_clfe.wav" )
		FileDelete ( $chemin & "\surcode_lsrs.wav" )
		
		If $decodage <> "mc" Then
			$appl = "C:\Program Files\MLP2all\channelx.exe surcode_down.wav 1 2"
			RunWait($appl,$chemin)
			FileDelete ( $chemin & "\surcode_down.wav" )
			FileMove($chemin & "\surcode_down_c1.wav", $chemin & "\wav\" & $file_sans_ext & "_downmix_FL.wav",8)
			FileMove($chemin & "\surcode_down_c2.wav", $chemin & "\wav\" & $file_sans_ext & "_downmix_FR.wav",8)
		EndIf

	Else

		If	$format = "mc" Then
			; Cration du fichier wav 6 canaux  partir de surcode_lfrf.wav, surcode_clfe.wav et surcode_lsrs.wav
			$appl = "C:\Program Files\MLP2all\interlx.exe " & $file_wav & " surcode_lfrf.wav surcode_clfe.wav surcode_lsrs.wav"
			RunWait($appl,$chemin)
		EndIf

		If	$format = "4ch" Then
			; Cration du fichier wav 4 canaux  partir de surcode_lfrf.wav et surcode_clfe.wav
			$appl = "C:\Program Files\MLP2all\interlx.exe " & $file_wav & " surcode_lfrf.wav surcode_clfe.wav"
			RunWait($appl,$chemin)
		EndIf
		
		If $format = "mc" OR $format = "4ch" Then
			; Effacement de surcode_lfrf.wav, surcode_clfe.wav et surcode_lsrs.wav
			FileDelete ( $chemin & "\surcode_lfrf.wav" )
			FileDelete ( $chemin & "\surcode_clfe.wav" )
			FileDelete ( $chemin & "\surcode_lsrs.wav" )
		
			Switch $cible
			Case "wav"
				FileMove($chemin & "\" & $file_wav, $chemin & "\wav\" & $file_wav,8)
			Case "wavpack"
				; Cration du fichier wavepack multicanaux dans ..\wavpack et effacement du fichier wav multicanaux (option -d)
				DirCreate($chemin & "\wavpack")
				$appl = "C:\Program Files\MLP2all\wavpack.exe -h -d -j0 " & $file_wav & " wavpack\" & $file_sans_ext & ".wv"
				RunWait($appl,$chemin)
			Case "flac"
				; FLAC tant capricieux sur le format multicanal qu'il accepte, il faut transcoder le wav produit par interlx
				if $format = "mc" Then
					$appl = "C:\Program Files\MLP2all\copysfx.exe -h0 -t4 " & $file_wav & " _" & $file_wav
				Else
					$appl = "C:\Program Files\MLP2all\copysfx.exe -h0 -t2 " & $file_wav & " _" & $file_wav					
				EndIf
				RunWait($appl,$chemin)
				FileDelete ( $chemin & "\" & $file_wav )
				; Cration du fichier flac multicanaux dans ..\flac et effacement du fichier wav multicanaux (option --delete-input-file)
				DirCreate($chemin & "\flac")
				$appl = "C:\Program Files\MLP2all\flac.exe --delete-input-file -8 _" & $file_wav & " -o flac\" & $file_sans_ext & ".flac"
				RunWait($appl,$chemin)
			EndSwitch 
		EndIf
	
		; Cas ou il y a en plus le fichier stro downmix  traiter qu'on soit en encodage multicanal ou stro
		If $decodage <> "mc" Then
			Switch $cible
			Case "wav"
				FileMove($chemin & "\surcode_down.wav", $chemin & "\wav\" & $file_sans_ext & "_downmix.wav",8)
			Case "wavpack"
				DirCreate($chemin & "\wavpack")
				$appl = "C:\Program Files\MLP2all\wavpack.exe -h -d surcode_down.wav wavpack\" & $file_sans_ext & "_downmix.wv"
				RunWait($appl,$chemin)
			Case "flac"
				DirCreate($chemin & "\flac")
				$appl = "C:\Program Files\MLP2all\flac.exe --delete-input-file -8 surcode_down.wav -o flac\" & $file_sans_ext & "_downmix.flac"
				RunWait($appl,$chemin)
			EndSwitch
			
			; Dans le cas du downmix, les fichiers multicanaux sont inutiles donc on les supprime 
			If $decodage = "downmix" Then
				FileDelete ( $chemin & "\surcode_lfrf.wav" )
				FileDelete ( $chemin & "\surcode_clfe.wav" )
				FileDelete ( $chemin & "\surcode_lsrs.wav" )			
			EndIf		
		EndIf
	
		; il ne reste plus qu' traiter le cas ou le dcodage comprend le multicanal et l'encodage est stro
		If $format = "stereo" Then
			Switch $cible
			Case "wav"
				; On dplace et renomme correctement les fichiers wav stro crs par Surcode 
				FileMove($chemin & "\surcode_lfrf.wav", $chemin & "\wav\" & $file_sans_ext & "_FLFR.wav",8)
				FileMove($chemin & "\surcode_clfe.wav", $chemin & "\wav\" & $file_sans_ext & "_CLFE.wav",8)
				FileMove($chemin & "\surcode_lsrs.wav", $chemin & "\wav\" & $file_sans_ext & "_SLSR.wav",8)
			Case "wavpack"				
				DirCreate($chemin & "\wavpack")
				$appl = "C:\Program Files\MLP2all\wavpack.exe -h -d surcode_lfrf.wav wavpack\" & $file_sans_ext & "_FLFR.wv"
				RunWait($appl,$chemin)
				$appl = "C:\Program Files\MLP2all\wavpack.exe -h -d surcode_clfe.wav wavpack\" & $file_sans_ext & "_CLFE.wv"
				RunWait($appl,$chemin)
				$appl = "C:\Program Files\MLP2all\wavpack.exe -h -d surcode_lsrs.wav wavpack\" & $file_sans_ext & "_SLSR.wv"
				RunWait($appl,$chemin)
			Case "flac"
				DirCreate($chemin & "\flac")
				$appl = "C:\Program Files\MLP2all\flac.exe --delete-input-file -8 surcode_lfrf.wav -o flac\" & $file_sans_ext & "_FLFR.flac"
				RunWait($appl,$chemin)
				$appl = "C:\Program Files\MLP2all\flac.exe --delete-input-file -8 surcode_clfe.wav -o flac\" & $file_sans_ext & "_CLFE.flac"
				RunWait($appl,$chemin)
				$appl = "C:\Program Files\MLP2all\flac.exe --delete-input-file -8 surcode_lsrs.wav -o flac\" & $file_sans_ext & "_SLSR.flac"
				RunWait($appl,$chemin)
			EndSwitch
		EndIf
		
	EndIf
WEnd

; Close the search handle
FileClose($search)

GUISetState(@SW_HIDE) ; on cache la fentre de progression
Switch $cible
Case "wav"
	$message = "Les fichiers wav sont dans le dossier " & $chemin & "\wav"
Case "wavpack"
	$message = "Les fichiers WavPack sont dans le dossier " & $chemin & "\wavpack"
Case "flac"
	$message = "Les fichiers flac sont dans le dossier " & $chemin & "\flac"
EndSwitch 
MsgBox(0, "Transcodage termin !", $message)
ArretMacro()

EndFunc
